"""dialog.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains classes for fancy looking transparent helper windows.
"""

# this entire system is a travesty
# I don't know precisely how many UI guidelines are buggered
# but it's a lot. still, first proper game. asking for it really

import globals as g

import os, sys

import tundra, level, font, music, player

from pgu import gui
from pgu.gui.const import *


class BoringDialog(gui.table.Table):
    """A boring dialog window.
    """
    def __init__(self, main,**params):
        params.setdefault('cls','dialog')
        gui.table.Table.__init__(self,**params)
                
        self.tr()
        self.td(main,cls=self.cls+".main")
        
#    def update(self, s):
#        if hasattr(self, "game") and self.game.app._repaint:
#            pass
#        else: self.paint(s)
#        return

class WellDoneDialog(BoringDialog):
    def __init__(self, game, **params):
        self.game = game
        self.main = gui.Table(width=g.FINISHDIALOG_WIDTH, height=g.FINISHDIALOG_HEIGHT)
        BoringDialog.__init__(self, self.main, **params)

#    def openSlightlyRaised(self,w=None,x=((g.SCREEN_WIDTH-g.FINISHDIALOG_WIDTH)/2),y=(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.FINISHDIALOG_HEIGHT - 8)/2)): # 8 is the table offset
    def openSlightlyRaised(self,w=None,x=None,y=None): # 8 is the table offset
        self.refresh()
        return self.open(w,((g.SCREEN_WIDTH-g.FINISHDIALOG_WIDTH)/2),(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.FINISHDIALOG_HEIGHT - 8)/2))

    def refresh(self):
        self.main.clear()
        self.main.td(gui.Image(font.createLayout(g.msg("finishDialog_diffdone1")+g.levelDB[self.game.collection][self.game.diffNum]["name"]+g.msg("finishDialog_diffdone2"),g.LEVELDIALOG_WIDTH, 128, 0)) , row=0, col=0)
        y = font.Icon(pygame.image.load(g.RESOURCES_PATH+"pixmaps/dialog-confirm.png").convert_alpha())
        y.connect(CLICK,self.closeTrigger)
        self.main.td(y, row=1, col=0)
        return
    
    def closeTrigger(self, *args):
        self.game.paused = False
        self.game.dialogIsActive = False
        self.game.diffNum = level.getLatestDifficulty(self.game.collection)
        self.game.levelNum = level.getLatestLevel(self.game.collection, self.game.diffNum)
        self.game.levelDialog.changeLevel(0)
        self.game.levelDialog.openSlightlyRaised()
        return self.close(*args)

class FinishDialog(BoringDialog):
    def __init__(self, game, outAsFraction=False, **params):
        self.game = game
        self.main = gui.Table(width=g.FINISHDIALOG_WIDTH, height=g.FINISHDIALOG_HEIGHT)
        self.outAsFraction = outAsFraction
        self.welldone = WellDoneDialog(self.game)
        BoringDialog.__init__(self,self.main,**params)

#    def openSlightlyRaised(self,title=g.msg("finishDialog_default"),w=None,x=((g.SCREEN_WIDTH-g.FINISHDIALOG_WIDTH)/2),y=(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.FINISHDIALOG_HEIGHT - 8)/2)): # 8 is the table offset
    def openSlightlyRaised(self,title=g.msg("finishDialog_default"),w=None,x=None,y=None): # 8 is the table offset
        self.title = title
        self.refresh()
        return self.open(w,((g.SCREEN_WIDTH-g.FINISHDIALOG_WIDTH)/2),(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.FINISHDIALOG_HEIGHT - 8)/2))

    def refresh(self):
        self.main.clear()
        self.titleImage = gui.Image(font.createLayout(self.title, g.LEVELDIALOG_WIDTH,40,0,highlight=False))
        if self.outAsFraction:
            rescued = repr(self.game.numLemmingsSaved)+"/"+repr(self.game.levelObj.numReleased) 
            goal = repr(self.game.levelObj.numToSave)+"/"+repr(self.game.levelObj.numReleased)
        else:
            rescued = repr(int(100*float(self.game.numLemmingsSaved)/self.game.levelObj.numReleased))+"%"
            goal = repr(int(100*float(self.game.levelObj.numToSave)/self.game.levelObj.numReleased))+"%"
        self.rescuedImage = gui.Image(font.createLayout(g.msg("finishDialog_rescued")+rescued, g.LEVELDIALOG_WIDTH,25,0))
        self.goalImage = gui.Image(font.createLayout(g.msg("finishDialog_goal")+goal, g.LEVELDIALOG_WIDTH,40,0))

        self.passed = False        

        if (self.game.numLemmingsSaved == 0):
            message = g.msg("finishDialog_none")
        elif (self.game.numLemmingsSaved == self.game.levelObj.numReleased):
            message = g.msg("finishDialog_all")
            self.passed = True        
        elif (self.game.numLemmingsSaved == self.game.levelObj.numToSave):
            message = g.msg("finishDialog_exact")
            self.passed = True
        elif (self.game.numLemmingsSaved > self.game.levelObj.numToSave):
            message = g.msg("finishDialog_over")
            self.passed = True
        elif (float(self.game.numLemmingsSaved)/self.game.levelObj.numReleased > (float(self.game.levelObj.numToSave)/self.game.levelObj.numReleased) - .05 ):
            message = g.msg("finishDialog_vclose")
        else:
            message = g.msg("finishDialog_few")

        self.messageImage = gui.Image(font.createLayout(message,g.LEVELDIALOG_WIDTH,80,0,highlight=False))
        
        if self.passed:
            score = g.msg("finishDialog_score1") + repr(self.game.getScore()) + g.msg("finishDialog_score2")
            self.scoreImage = gui.Image(font.createLayout(score,g.LEVELDIALOG_WIDTH,40,0))
        else:
            self.scoreImage = gui.Label("")
        # TODO: Once scoring system is in, add "you bested your previous record by +1 lemming and +4 seconds!"
        # by default, more lemmings overrides a worse time, however one can recoup this loss
        
        # TODO: Once really REALLY scrambling for things to do, add instant replay

        self.x = font.Icon(pygame.image.load(g.RESOURCES_PATH+"pixmaps/dialog-confirm.png").convert_alpha())
        self.x.connect(CLICK,self.closeTrigger,None)

        self.main.td(self.titleImage, row=0, col=0)
        self.main.td(self.rescuedImage, row=1, col=0)
        self.main.td(self.goalImage, row=2, col=0)
        self.main.td(self.messageImage, row=3, col=0)
        self.main.td(self.scoreImage, row=4, col=0)
        self.main.td(self.x, row=5, col=0)

        return

    def closeTrigger(self, *args):
        if self.passed:
            dict = g.levelDB[self.game.collection][self.game.diffNum]
            if (self.game.levelNum in dict):
# if the number of lemmings saved was greater than the high score, or alternatively if the number of lemmings
# saved was exactly the same but the score is higher than your current best, then set it as a new record
                if (dict[self.game.levelNum].bestSaved < self.game.numLemmingsSaved) or ((dict[self.game.levelNum].bestSaved == self.game.numLemmingsSaved) and (dict[self.game.levelNum].bestScore < self.game.getScore())):
                    dict[self.game.levelNum].bestSaved = self.game.numLemmingsSaved
                    dict[self.game.levelNum].bestTime = self.game.reverseTimer
                    dict[self.game.levelNum].bestScore = self.game.getScore()
            if (self.game.levelNum+1 in dict):
                dict[self.game.levelNum+1].access = True
                player.saveLevelDB(g.CONFIG_FILE)
                self.game.levelDialog.increaseLevel()
            else:
                player.saveLevelDB(g.CONFIG_FILE)
                self.welldone.openSlightlyRaised()
                return self.close(*args)
        else:
            self.game.refresh()
            self.game.refreshMaskedSprites()
        self.game.paused = False
        self.game.dialogIsActive = False
        self.game.levelDialog.openSlightlyRaised()
        return self.close(*args)
        

class LoaderDialog(BoringDialog):
    def __init__(self, startPage=0, **params):
        self.main = gui.Table(width=g.LOADERDIALOG_WIDTH, height=g.LOADERDIALOG_HEIGHT)
        self.editArea = gui.Table(width=g.LOADERDIALOG_WIDTH-96, height=g.LOADERDIALOG_HEIGHT-96)
        self.renderPage(startPage)
        BoringDialog.__init__(self, self.main, **params)

    def renderPage(self, index):
        if index == 0:
            self.editArea.clear()
            self.editArea.td(gui.Image(font.createLayout(g.msg("loader_intro"), g.LOADERDIALOG_WIDTH-128, g.LOADERDIALOG_HEIGHT-128, 0)), row=0, col=0)
            
            self.main.clear()
            self.main.td(self.editArea, row=0, col=0)
            b = gui.Button(g.msg("loader_intro_button"))
            b.connect(gui.CLICK,self.renderPage,1)
            self.main.td(b, row=1, col=0)
        elif index == 1:
            self.editArea.clear()
            self.editArea.td(gui.Image(font.createLayout(g.msg("loader_profile"), g.LOADERDIALOG_WIDTH-128, g.LOADERDIALOG_HEIGHT-256, 0)), row=0, col=0)
            self.nameBox = gui.Input(size=16)
            self.editArea.td(self.nameBox, row=1, col=0)
            self.main.clear()
            self.main.td(self.editArea, row=0, col=0)

            def checkInputBox():
                if not self.nameBox.value == "":
                    g.PLAYER_NAME = self.nameBox.value
                    self.renderPage(2)
            
            b = gui.Button(g.msg("loader_profile_button"))
            b.connect(gui.CLICK,checkInputBox)
            self.main.td(b, row=1, col=0)
        elif index == 2:
            self.editArea.clear()
            self.editArea.td(gui.ScrollArea(gui.Image(font.createLayout(g.msg("loader_disclaimer"), g.LOADERDIALOG_WIDTH-128, int(g.LOADERDIALOG_HEIGHT*2.6), -1, highlight=False)),g.LOADERDIALOG_WIDTH-96, 252, hscrollbar=False), row=0, col=0)
        
            self.main.clear()
            self.main.td(self.editArea, row=0, col=0)
            b = gui.Button(g.msg("loader_disclaimer_button"))
            b.connect(gui.CLICK,self.renderPage,3)
            self.main.td(b, row=1, col=0)
        elif index == 3:
            self.question = gui.Group()
            self.editArea.clear()
            self.editArea.td(gui.Image(font.createLayout(g.msg("loader_question"), 404, 32, -1, highlight=False)), row=0, col=0, colspan=2)
            self.editArea.td(gui.Radio(self.question, value=True), row=1, col=0)
            self.editArea.td(gui.Spacer(8, 96), row=2, col=0)
            self.editArea.td(gui.ScrollArea(gui.Image(font.createLayout(g.msg("loader_questionyes"), 350, 234, -1, highlight=False)), 372, 108, hscrollbar=False), row=1, col=1, rowspan=2)
            self.editArea.td(gui.Spacer(8,16), row=3, col=0, colspan=2)
            self.editArea.td(gui.Radio(self.question, value=False), row=4, col=0)
            self.editArea.td(gui.Spacer(8, 96), row=5, col=0)
            self.editArea.td(gui.ScrollArea(gui.Image(font.createLayout(g.msg("loader_questionno"), 350, 378, -1, highlight=False)), 372, 108, hscrollbar=False), row=4, col=1, rowspan=2)
            
            self.main.clear()
            self.main.td(self.editArea, row=0, col=0)
            b = gui.Button(g.msg("loader_question_button"))
            b.connect(gui.CLICK,self.renderPage,4)
            self.main.td(b, row=1, col=0)
        elif index == 4:
            if not hasattr(self, "question") or (self.question.value == None):
                return
            elif not self.question.value:
                self.editArea.clear()
                self.editArea.td(gui.Image(font.createLayout(g.msg("loader_failedquestion"), g.LOADERDIALOG_WIDTH-128, g.LOADERDIALOG_HEIGHT-128, 0)), row=0, col=0)
            
                self.main.clear()
                self.main.td(self.editArea, row=0, col=0)
                
                def fuckOff(): raise SystemExit
                b = gui.Button(g.msg("loader_failedquestion_button"))
                b.connect(gui.CLICK,fuckOff)
                self.main.td(b, row=1, col=0)
            else:
                try:
                    os.makedirs(g.RESOURCES_PATH+"styles")
                except OSError:
                    pass
                try:
                    os.makedirs(g.RESOURCES_PATH+"levels")
                except OSError:
                    pass
                styles = os.listdir(g.RESOURCES_PATH+"styles")
                if "default" in styles:
                    styles.pop(styles.index("default"))
                if len(styles) == 0:
                    message = g.msg("loader_nostyles")
                    self.decrunch = True
                elif len(os.listdir(g.RESOURCES_PATH+"levels")) == 0:
                    message = g.msg("loader_nolevels")
                    self.decrunch = True
                else:
                    message = g.msg("loader_full")
                    self.decrunch = False
                
                self.editArea.clear()
                self.editArea.td(gui.Image(font.createLayout(message, g.LOADERDIALOG_WIDTH-128, g.LOADERDIALOG_HEIGHT-128, 0)), row=0, col=0)
            
                self.main.clear()
                self.main.td(self.editArea, row=0, col=0)
                b = gui.Button(g.msg("loader_full_button"))
                if self.decrunch:
                    b.connect(gui.CLICK,self.renderPage,"decrunch_lite")
                else:
                    level.makeLevelDB()
                    player.saveLevelDB(g.CONFIG_FILE)
                    b.connect(gui.CLICK,self.buggerOff)
                
                self.main.td(b, row=1, col=0)
        elif index == "options":
            self.editArea.clear()
            self.musicArea = gui.Table(width=g.LOADERDIALOG_WIDTH-96, height=18)
            self.musicArea.td(gui.Image(font.stringToBitmap("Music:", highlight=False)), row=0, col=0)

            s = gui.Select()
            s.add("Random","random")
            for f in [g.RESOURCES_PATH+"music/"+x for x in os.listdir(g.RESOURCES_PATH+"music") if os.path.isfile(g.RESOURCES_PATH+"music/"+x) and not (x.find("xml") == -1)]:
                s.add(os.path.split(f)[-1].split(".")[0],os.path.split(f)[-1].split(".")[0])
            s.value = g.MUSIC_PLAYLIST
            def changePlaylist(): g.MUSIC_PLAYLIST = s.value
            s.connect(CHANGE, changePlaylist)
            self.musicArea.td(s, row=0, col=1)
            
            t = gui.Switch(g.ENABLE_MUSIC)
            def changeEnable(): g.ENABLE_MUSIC = t.value
            t.connect(CHANGE, changeEnable)
            self.musicArea.td(t, row=0, col=2)
            self.musicArea.td(gui.Image(font.stringToBitmap("Enable", highlight=False)), row=0, col=3)

            t = gui.Switch(g.RANDOM_MUSIC)
            def changeRandom(): g.RANDOM_MUSIC = t.value
            t.connect(CHANGE, changeRandom)
            self.musicArea.td(t, row=0, col=4)
            self.musicArea.td(gui.Image(font.stringToBitmap("Random", highlight=False)), row=0, col=5)

            self.editArea.td(self.musicArea, row=0, col=0)

            self.screenArea = gui.Table(width=g.LOADERDIALOG_WIDTH-96, height=18)
            
            self.screenArea.td(gui.Image(font.stringToBitmap("Screen:", highlight=False)), row=0, col=0)
            slider = gui.HSlider(g.SCREEN_WIDTH, 640, 840,size=24, height=16,width=128, step=4)
            self.screenArea.td(slider, row=0, col=1)
            fs = gui.Switch(g.ENABLE_FULLSCREEN)
            def changeFull(): g.ENABLE_FULLSCREEN = fs.value
            fs.connect(CHANGE, changeFull)
            self.screenArea.td(fs, row=0, col=2)
            self.screenArea.td(gui.Image(font.stringToBitmap("Fullscreen", highlight=False)), row=0, col=3)
            sb = gui.Button("Apply")
            self.parent = None# needs to be changed on the outside
            def changeScreen():
                # TODO: save user from themselves, force 640*480 fullscreen
                g.ENABLE_FULLSCREEN = fs.value
                if fs.value:                
                    g.SCREEN_WIDTH = 640                
                else:
                    g.SCREEN_WIDTH = slider.value
                tundra.updateScreenSize()
                self.parent.switchLoops("Title")
            sb.connect(CLICK, changeScreen)                
            self.screenArea.td(sb, row=0, col=4)

            self.editArea.td(self.screenArea, row=1, col=0)
            
            self.miscArea = gui.Table(width=g.LOADERDIALOG_WIDTH-96, height=18)
            self.miscArea.td(gui.Image(font.stringToBitmap("Name:", highlight=False)), row=0, col=0)
            nb = gui.Input(size=16)
            nb.value = g.PLAYER_NAME
            def changeName(): g.PLAYER_NAME = nb.value
            nb.connect(CHANGE, changeName)
            self.miscArea.td(nb, row=0, col=1)
            smooth = gui.Switch(g.ENABLE_SMOOTHING)
            def changeSmooth(): g.ENABLE_SMOOTHING = smooth.value
            smooth.connect(CHANGE, changeSmooth)
            self.miscArea.td(smooth, row=0, col=2)
            self.miscArea.td(gui.Image(font.stringToBitmap("Scale2x", highlight=False)), row=0, col=3)
            
            self.editArea.td(self.miscArea, row=2, col=0)

            self.decrunchArea = gui.Table(width=g.LOADERDIALOG_WIDTH-96, height=18)
            self.decrunchArea.td(gui.Image(font.stringToBitmap("Decruncher:", highlight=False)), row=0, col=0)            
            decb = gui.Button("Import game resources")     
            decb.connect(CLICK,self.renderPage,"decrunch_lite")
            self.decrunchArea.td(decb, row=0, col=1)
    
            self.editArea.td(self.decrunchArea, row=3, col=0)

            self.main.clear()
            self.main.td(self.editArea, row=0, col=0)
            b = gui.Button("Save")
            b.connect(CLICK,self.buggerOff)
            self.main.td(b, row=1, col=0)
        elif index == "decrunch_lite": #this is a terrible hack: I will make a proper dialog class when the need arises
            import decrunch as d
            self.dpath = os.getcwd()
            def handle_file_browser_closed(dlg):
                if dlg.value: self.dpath = dlg.value
                reload()
            
            def reload():
                self.editArea.clear()
                self.main.clear()
                self.dtitle, self.dtitleargs = d.checkDir(self.dpath)
                self.editArea.td(gui.Image(font.createLayout("Please browse to your DOS Lemmings folder", g.LOADERDIALOG_WIDTH-64, 24, 0)), row=0, col=0, colspan=2)
                if len(self.dpath) > 25:
                    self.editArea.td(gui.Image(font.stringToBitmap("Folder: "+self.dpath[:10]+"..."+self.dpath[-15:]+"  ")), row=1, col=0, align=-1)
                else: self.editArea.td(gui.Image(font.stringToBitmap("Folder: "+self.dpath+"  ")), row=1, col=0, align=-1)
                self.editArea.td(b, row=1, col=1)
                self.editArea.td(gui.Image(font.stringToBitmap("Contains: "+self.dtitle)), row=2, col=0, colspan=2, align=-1)
                if self.dtitle == g.msg("decrunch_nogame"):
                    w = gui.Spacer(g.LOADERDIALOG_WIDTH-96, 200)
                else:
                    w = gui.Table(width=g.LOADERDIALOG_WIDTH-96, height=200)
                    self.boolargs = []
                    for x in xrange(len(self.dtitleargs)):
                        self.boolargs.append(gui.Switch(True))
                        w.td(self.boolargs[-1], row=x, col=0)
                        w.td(gui.Spacer(8,18), row=x, col=1)
                        w.td(gui.Image(font.stringToBitmap(self.dtitleargs[x])),row=x, col=2, align=-1)
                self.editArea.td(w, row=3, col=0, colspan=2)
                self.main.td(self.editArea, row=0, col=0, colspan=3)
                self.main.td(dc, row=1, col=0)
                self.main.td(gui.Spacer(180,8), row=1, col=1)
                self.main.td(r, row=1, col=2)
                

            def startRip():
                if self.dtitle == g.msg("decrunch_nogame"):
                    return
                self.main.clear()
                self.main.td(self.editArea, row=0, col=0)
                self.main.td(gui.Image(font.stringToBitmap("WORKING - Please wait...")), row=1, col=0)
                gui.app.App.app.paint(g.screen)
                pygame.display.flip()
                d.ripTitle(self.dtitle, self.dpath, map((lambda a: a.value), self.boolargs))
                level.makeLevelDB()
                reload()

            def checkLeave():
                styles = [f for f in os.listdir(g.RESOURCES_PATH+"styles") if not f.startswith(".")]
                levels = [f for f in os.listdir(g.RESOURCES_PATH+"levels") if not f.startswith(".")]
        
                if "default" in styles:
                    styles.pop(styles.index("default"))
        
                needsResources = ((len(styles) == 0) or (len(levels) == 0))
                if not needsResources:
                    self.buggerOff()
                return


            f = FileDialog(folder=True)
            f.connect(gui.CHANGE, handle_file_browser_closed, f)
            b = gui.Button("Browse")
            b.connect(gui.CLICK, f.open, None)
            r = gui.Button("Rip")
            r.connect(gui.CLICK, startRip)
            dc = gui.Button("Leave")
            dc.connect(gui.CLICK, checkLeave)
            reload()
        return
    
    def buggerOff(self):
        self.send(gui.CHANGE) 
        player.saveLevelDB(g.CONFIG_FILE)
        self.close()
        return

class LevelDialog(BoringDialog):
    def __init__(self, game, **params):
        self.game = game
        self.quickLoadDialog = QuickLoadDialog()
        self.main = gui.Table(width=g.LEVELDIALOG_WIDTH, height=g.LEVELDIALOG_HEIGHT)

        self.l = font.Icon(pygame.image.load(g.RESOURCES_PATH+"pixmaps/dialog-left.png").convert_alpha())
        self.l.connect(CLICK,self.decreaseLevel,None)
        self.ln = font.Icon(pygame.image.load(g.RESOURCES_PATH+"pixmaps/dialog-noleft.png").convert_alpha())
        
        self.x = font.Icon(pygame.image.load(g.RESOURCES_PATH+"pixmaps/dialog-start.png").convert_alpha())
        self.x.connect(CLICK,self.closeTrigger,None)
        self.r = font.Icon(pygame.image.load(g.RESOURCES_PATH+"pixmaps/dialog-right.png").convert_alpha())
        self.r.connect(CLICK,self.increaseLevel,None)
        self.rn = font.Icon(pygame.image.load(g.RESOURCES_PATH+"pixmaps/dialog-noright.png").convert_alpha())
        
        self.showScore = False

        self.changeLevel(0, bypass=True)

        BoringDialog.__init__(self, self.main,**params)
        
    def increaseLevel(self, *args):
        self.changeLevel(1,*args)

    def decreaseLevel(self, *args):
        self.changeLevel(-1,*args)
    
    def changeLevel(self, inc, bypass=False, *args):
        self.game.levelNum += inc
        if not bypass:
            self.game.changeCurrentLevel(self.game.collection, self.game.diffNum, self.game.levelNum)
            self.game.refresh()
        self.main.clear()
        
        self.titleImage = font.Icon(font.createLayout(self.game.collection+" - "+level.getDifficultyString(self.game.collection, self.game.diffNum)+" - Level "+repr(self.game.levelNum+1),g.LEVELDIALOG_WIDTH,18,0,highlight=False)) 
        self.quickLoadDialog.connect(gui.CHANGE, self.updateLevelSet, self.quickLoadDialog)
        self.titleImage.connect(CLICK,self.openQuickLoadDialog, None)

        self.main.td(self.titleImage, col=0, row=0, colspan=3)
        
        self.preview = gui.Image(self.game.levelObj.printTerrain(crop=True, showInter=True, preview=True))
        self.main.td(self.preview, col=0, row=1, colspan=3)

        self.nameImage = gui.Image(font.createLayout(self.game.levelObj.levelName,g.LEVELDIALOG_WIDTH,60,0,highlight=False))
        self.main.td(self.nameImage, col=0, row=2, colspan=3)
        
        self.authorImage = gui.Image(font.createLayout(self.game.levelObj.author,g.LEVELDIALOG_WIDTH,25,0,highlight=False))        
        self.main.td(self.authorImage, col=0, row=3, colspan=3)

        self.goalImage = gui.Image(font.createLayout("Goal: Rescue "+repr(self.game.levelObj.numToSave)+"/"+repr(self.game.levelObj.numReleased)+" in "+repr(self.game.levelObj.timeLimit/60)+";"+repr((self.game.levelObj.timeLimit%60) + 100)[1:],g.LEVELDIALOG_WIDTH,25,0))       
        self.main.td(self.goalImage, col=0, row=4, colspan=3)
        
        levHandle = g.levelDB[self.game.collection][self.game.diffNum][self.game.levelNum]
        if not (levHandle.bestTime == 0):
            if not self.showScore:
                self.highScoreImage = font.Icon(font.createLayout("Best: "+repr(levHandle.bestSaved)+"/"+repr(self.game.levelObj.numReleased)+" rescued in "+repr(levHandle.bestTime/60)+";"+repr((levHandle.bestTime%60) + 100)[1:],g.LEVELDIALOG_WIDTH,25,0))
            else:
                self.highScoreImage = font.Icon(font.createLayout("Best: "+repr(levHandle.bestScore)+" points",g.LEVELDIALOG_WIDTH,25,0))

            def toggleScore(): self.showScore = not self.showScore; self.changeLevel(0, bypass=True);
            self.highScoreImage.connect(gui.CLICK, toggleScore)
        else:
            self.highScoreImage = gui.Spacer(g.LEVELDIALOG_WIDTH,25)
        self.main.td(self.highScoreImage, col=0, row=5, colspan=3)

        
        if not ((self.game.levelNum-1) in g.levelDB[self.game.collection][self.game.diffNum]):
            self.main.td(self.ln,col=0,row=6)
        elif not g.levelDB[self.game.collection][self.game.diffNum][self.game.levelNum-1].access:
            self.main.td(self.ln,col=0,row=6)
        else:
            self.main.td(self.l,col=0,row=6)

        self.main.td(self.x,col=1,row=6)
        if not ((self.game.levelNum+1) in g.levelDB[self.game.collection][self.game.diffNum]):
            self.main.td(self.rn,col=2,row=6)
        elif not g.levelDB[self.game.collection][self.game.diffNum][self.game.levelNum+1].access:
            self.main.td(self.rn,col=2,row=6)
        else:
            self.main.td(self.r,col=2,row=6)

        return
    
    # see note for openSlightlyRaised in LevelDialog
#    def openSlightlyRaised(self,w=None,x=((g.SCREEN_WIDTH-g.LEVELDIALOG_WIDTH)/2),y=(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.LEVELDIALOG_HEIGHT - 8)/2)): # 8 is the table offset
    def openSlightlyRaised(self,w=None,x=None,y=None): # 8 is the table offset
        self.game.paused = True
        self.game.dialogIsActive = True
        return self.open(w,((g.SCREEN_WIDTH-g.LEVELDIALOG_WIDTH)/2),(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.LEVELDIALOG_HEIGHT - 8)/2))

    def closeTrigger(self, *args):
        self.game.paused = False
        self.game.dialogIsActive = False
        self.game.initializeLevelFinal()
        return self.close(*args)
    
    def openQuickLoadDialog(self, *args):
        self.game.pauseRendering = True
        self.quickLoadDialog.openSlightlyRaised(*args)
        return
        

    def updateLevelSet(self, quickLoadDialog):
        self.game.pauseRendering = False
#        print quickLoadDialog.collectionList.value,quickLoadDialog.difficultyList.value,quickLoadDialog.levelList.value
        if not quickLoadDialog.collectionList.value == None: 
            self.game.collection = quickLoadDialog.collectionList.value
            self.game.music.setCollection(self.game.collection)
        if not quickLoadDialog.difficultyList.value == None: 
            self.game.diffNum = quickLoadDialog.difficultyList.value
        else:
            self.game.diffNum = level.getLatestDifficulty(self.game.collection)
        if not quickLoadDialog.levelList.value == None: 
            self.game.levelNum = quickLoadDialog.levelList.value
        else:
            self.game.levelNum = level.getLatestLevel(self.game.collection, self.game.diffNum)              
        self.changeLevel(0)


class QuickLoadDialog(BoringDialog):
    def __init__(self, **params):
        self.main = gui.Table(width=int(g.QUICKLOADDIALOG_WIDTH), height=g.QUICKLOADDIALOG_HEIGHT)
        self.collectionList = gui.List(width=120, height=130)
        
        collections = g.levelDB.keys()
        collections.sort()
        for x in collections:
            self.collectionList.add(x,value=x)          
        self.collectionList.connect(CHANGE,self.collectionChanged)
        self.collectionList.resize()
        self.collectionList.repaint()

        self.main.td(gui.Image(font.createLayout("Collection",120,20,0)), col=0, row=0)

        self.difficultyList = gui.List(width=120, height=130)
        self.difficultyList.connect(CHANGE,self.difficultyChanged)

        self.main.td(gui.Image(font.createLayout("Difficulty",120,20,0)), col=1, row=0)

        self.levelList = gui.List(width=180, height=130)
        self.main.td(gui.Image(font.createLayout("Level",180,20,0)), col=2, row=0)

        self.gopherIt = gui.Button("Hooray!")
        self.gopherIt.connect(gui.CLICK, self.buggerOff)

        self.main.td(self.collectionList , col=0, row=1)
        self.main.td(self.difficultyList , col=1, row=1)
        self.main.td(self.levelList , col=2, row=1)
        self.main.td(self.gopherIt , row=2, colspan=3)


        BoringDialog.__init__(self,self.main,**params)

    def buggerOff(self):
        self.send(gui.CHANGE)        
        self.close()

    def collectionChanged(self):
        self.difficultyList.clear()
        self.difficultyList.resize()
        self.difficultyList.repaint()
        self.difficultyList.value = None

        self.levelList.clear()
        self.levelList.resize()
        self.levelList.repaint()
        self.levelList.value = None
    
        if self.collectionList.value == None:
            return

#        testPath = g.RESOURCES_PATH + "levels/"+ self.collectionList.value+"/"
#
#        difficulties = [int(x.split(" ")[0]) for x in os.listdir(testPath) if os.path.isdir(testPath + x)]
#        difficulties.sort()
#        for d in difficulties:       
#            self.difficultyList.add(level.getDifficultyString(self.collectionList.value,d), value=d)
        difficulties = g.levelDB[self.collectionList.value].keys()
        difficulties.sort()
        for d in difficulties:
            self.difficultyList.add(level.getDifficultyString(self.collectionList.value,d), value=d)

        
        self.difficultyList.resize()
        self.difficultyList.repaint()
        return

    def difficultyChanged(self):
        self.levelList.clear()
        self.levelList.resize()
        self.levelList.repaint()
        self.levelList.value = None
        if self.difficultyList.value == None:
            return
#        tempPath = level.getLevelPath(self.collectionList.value, self.difficultyList.value)
#        levels = [int(x.split(".")[0]) for x in os.listdir(tempPath) if os.path.isfile(tempPath + x)]
#        levels.sort()
        dict = g.levelDB[self.collectionList.value][self.difficultyList.value]
        # TODO: remove last flag for debugging purposes ONLY
        levels = [k for k in dict.iterkeys() if not (dict[k].__class__ == str)]# and dict[k].access]
        levels.sort()
        for l in levels:
            self.levelList.add(repr(l+1)+".) "+g.levelDB[self.collectionList.value][self.difficultyList.value][l].name,value=l)
        self.levelList.resize()
        self.levelList.repaint()
        return

    # NOTE:
    # I had to make a small modification to PGU for this to work. Namely, editing container.py and 
    # widget.py to actually pass the x and y parameters to open() for a dialog window.
    # This way, you can define where onscreen a dialog should open. Sort of like what the feature
    # is supposed to do :) 
#    def openSlightlyRaised(self,w=None,x=((g.SCREEN_WIDTH-g.QUICKLOADDIALOG_WIDTH)/2),y=(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.QUICKLOADDIALOG_HEIGHT - 8)/2)): # 8 is the table offset
    def openSlightlyRaised(self,w=None,x=None,y=None): # 8 is the table offset
        self.difficultyChanged()
        return self.open(w,((g.SCREEN_WIDTH-g.QUICKLOADDIALOG_WIDTH)/2),(g.TOPBAR_HEIGHT+(g.PLAYAREA_HEIGHT-g.QUICKLOADDIALOG_HEIGHT - 8)/2))


# modded from PGU filedialog

class FileDialog(BoringDialog):
    """A file picker dialog window.
    
    <pre>FileDialog()</pre>
    <p>Some optional parameters:</p>
    <dl>
    <dt>button_txt<dd>button text
    <dt>path<dd>initial path
    </dl>
    """
    
    def __init__(self, button_txt="Okay", cls="dialog", path=None, folder=False):
        
        cls1 = 'filedialog'
        if not path: self.curdir = os.getcwd()
        else: self.curdir = path
        app = gui.app
        area = gui.area
        table = gui.table
        basic = gui.basic
        input = gui.input
        button = gui.button
        self.folderOnly = folder
        self.dir_img = basic.Image(app.App.app.theme.get(cls1+'.folder', '', 'image'))
        td_style = {'padding_left': 4,
                    'padding_right': 4,
                    'padding_top': 2,
                    'padding_bottom': 2}
        self.body = table.Table()
        self.list = area.List(width=400, height=150)
        self.input_dir = input.Input()
        self.input_file = input.Input()
        self._list_dir_()
        self.button_ok = button.Button(button_txt)
        self.body.tr()
        self.body.td(gui.Image(font.createLayout("Folder:", 96, 18, -1)), style=td_style, align=-1)
        self.body.td(self.input_dir, style=td_style)
        self.body.tr()
        self.body.td(self.list, colspan=3, style=td_style)
        self.list.connect(CHANGE, self._item_select_changed_, None)
        self.button_ok.connect(CLICK, self._button_okay_clicked_, None)
        self.body.tr()
        if not self.folderOnly:
            self.body.td(gui.Image(font.createLayout("File:", 96, 18, -1)), style=td_style, align=-1)
            self.body.td(self.input_file, style=td_style)
        else:
            self.body.td(gui.Spacer(16, 16), colspan=2)
        self.body.td(self.button_ok, style=td_style)
        self.value = None

        self.input_dir.connect(CHANGE, self._input_edited_callback_, None)

        BoringDialog.__init__(self, self.body)
        
    def _list_dir_(self):
        self.input_dir.value = self.curdir
        self.input_dir.pos = len(self.curdir)
        self.input_dir.vpos = 0
        dirs = []
        files = []
        try:
            for i in os.listdir(self.curdir):
                if os.path.isdir(os.path.join(self.curdir, i)): dirs.append(i)
                else: files.append(i)
        except:
            self.input_file.value = "Bollocks."
        dirs.sort()
        dirs = ['..'] + dirs
        files.sort()

        self.list.clear()
        for i in dirs:
            self.list.add(i,image=self.dir_img,value=i)
        if not self.folderOnly:
            for i in files:
                self.list.add(i,value=i)
        
        self.list.set_vertical_scroll(0)
        
    def _input_edited_callback_(self, arg):
        if os.path.isdir(self.input_dir.value):
            self.curdir = self.input_dir.value
            self._list_dir_() 
        #else:
        #    self.input_dir.value = self.curdir
            
        
    def _item_select_changed_(self, arg):
        self.input_file.value = self.list.value
        fname = os.path.abspath(os.path.join(self.curdir, self.input_file.value))
        if os.path.isdir(fname):
            self.input_file.value = ""
            self.curdir = fname
            self._list_dir_()


    def _button_okay_clicked_(self, arg):
        if self.input_dir.value != self.curdir:
            if os.path.isdir(self.input_dir.value):
                self.input_file.value = ""
                self.curdir = os.path.abspath(self.input_dir.value)
                self._list_dir_()
        else:
            self.value = os.path.join(self.curdir, self.input_file.value)
            
        if self.folderOnly:
            self.value = self.curdir

        self.send(CHANGE)
        self.close()
