"""playerconfig.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains methods for loading and dumping player config files.
"""
import globals as g
import level
import ser, gzip

# the following globals will be saved in the player file
attributes = ["PLAYER_NAME", "START_COLLECTION", "SCREEN_WIDTH", "ENABLE_FULLSCREEN", 
              "ENABLE_SMOOTHING", "ENABLE_MUSIC", "RANDOM_MUSIC", "MUSIC_PLAYLIST"]

class Record:
    def __init__(self, access, name):
        self.name = name
        self.bestTime = 0
        self.bestScore = 0
        self.bestSaved = 0
        self.bestSavedPercent = 0
        self.access = access
        self.demo = None   # TODO: write demo recorder/playback class



ser.register(Record)

def loadLevelDB(filename):
    f = gzip.open(filename, "rb")
    attrs, newDB = ser.load(f)
    for a in attrs.iteritems():
        setattr(g, a[0], a[1])
    g.refresh()
    f.close()
    g.levelDB = newDB
    level.makeLevelDB()
    return

def saveLevelDB(filename):
    f = gzip.open(filename, "wb")
    attrs = {}
    for a in attributes:
        attrs[a] = getattr(g,a)
    ser.dump( (attrs, g.levelDB), f)
    f.close()
    return
