"""s_actclimber.py

Part of the Tundra project.
(C) 2006 Rebuild Software
http://rebui.ld.net.au

This file contains the classic definition of the lemming climber action.
"""

import globals as g
from excepts import *

attrs = {"isDeathAction": False, "isOnGround": False, "mustStartOnGround": False, "propertyChangeOnly": False }
frames = {-1:[[],None] , 1:[[],None]}

# when detecting whether to climb, use the bottom
# when actually climbing up, use a few pixels up, say 7

def update(lemming):
    try:
        if lemming.checkPos((lemming.posX - lemming.direction, lemming.posY-6), "ground") or not lemming.checkPos((lemming.posX, lemming.posY-5), "ground"):
            lemming.posX -= lemming.direction
            lemming.direction *= -1
            lemming.setSkill("s_faller")
            return
        elif not lemming.checkPos((lemming.posX, lemming.posY-6), "ground"):
            lemming.setSkill("s_postclimber")
            return

        if lemming.currentFrame >= 4:
            lemming.posY -= 1
        lemming._incAnimFrame()

    except OutOfThePlayfield:
        lemming.posX -= lemming.direction
        lemming.direction *= -1
        lemming.setSkill("s_faller")
    return

def set(lemming):
    lemming.currentSkill = "s_actclimber"
    lemming.currentFrame = 0
    lemming.posX += lemming.direction
    lemming.rect.left = frames[1][1].left
    lemming.rect.right = frames[1][1].right
    lemming.rect.width = frames[1][1].width
    lemming.rect.height = frames[1][1].height
    lemming.frameCount = len(frames[1][0])
    lemming._incAnimFrame()
    return
